function packet = consensusEstimator(packets, n)
% Run PI consensus estimator for bot number 'n'

global N PACKET_AGE_LIMIT GAMMA A_COEFF B_COEFF

% simple weighting: only count bots with valid packets
weights = ([packets.age] <= PACKET_AGE_LIMIT);
a = weights*A_COEFF;
b = weights*B_COEFF;

w = zeros(size(packets(n)));
for j=1:N
    w = w - b(j)*(packets(n).v - packets(j).v);
end

v = zeros(size(packets(n)));
for j=1:N
    v = v - a(j)*(packets(n).v - packets(j).v) ...
          + b(j)*(packets(n).w - packets(j).w);
end
packet = packets(n);
packet.v = v;
packet.w = w;
end