function u = controller(sensory, packet)
% Calculate velocity from cost function derivative

global CENTRAL_MOMENTS GOAL U_GAINS


p = sensory.p;
v = packet.v;
if CENTRAL_MOMENTS
    partials = [1   0   2*p(1)-2*v(1)     p(2)-v(2)     0    ;
                0   1   0                 p(1)-v(1)     2*p(2)-2*v(2)];
    v = v - [0   0   v(1)^2    v(1)*v(2)   v(2)^2]';
else
    partials = [1   0   2*p(1)  p(2)    0   ;
                0   1   0       p(1)    2*p(2)];
end

u = -partials*U_GAINS*(v-GOAL);
end