function state = plant(bot)
% update position

global dT MAX_U POINT_R


if norm(bot.u) > MAX_U
    u = bot.u/norm(bot.u)*MAX_U;
else
    u = bot.u;
end
state = bot.state;
state.angle = updateAngle(bot.state, u);
state.p = bot.state.p + u*dT;



    % As a robot moves, calculate the resulting rotation -- display purposes only
    function angle = updateAngle(state, u)
        A = calcCenterPoint(state);
        B = state.p;
        D = B + u*dT;
        C = (B + D)/2;
        AB = B-A;
        BD = D-B;
            %nasty solution to {AB.AE=0 and BD.CE=0}
        E = [(AB(1)*A(1)*BD(2)+AB(2)*(A(2)*BD(2)-BD(1)*C(1)-BD(2)*C(2))) /...
            (AB(1)*BD(2)-AB(2)*BD(1)); 0];
        E(2) = (BD(1)*(C(1)-E(1))+BD(2)*C(2))/BD(2);
        arg = norm(C-D)/norm(E-D);
        if abs(arg) > 1 || isnan(arg)
            angle = state.angle;
        else
            crs = cross([AB(1), AB(2), 0], [BD(1), BD(2), 0]);
            angle = state.angle + sign(dot(A-B, A-D))*sign(crs(3))*2*asin(arg);
        end
    end

    % Get the center point of the robot (based on angle and register point)
    function p = calcCenterPoint(state)
        p = state.p - [cos(state.angle); sin(state.angle)]*POINT_R;
    end
end